shell-conduit-5.0.0: Write shell scripts with Conduit

Safe Haskell | None
Language | Haskell2010

Data.Conduit.Shell.Types

Description

All types.

Synopsis

- newtype ShellT (m :: Type -> Type) a = ShellT {
  - runShellT :: ResourceT m a
  }
- data ShellException
  - = ShellEmpty
  - | ShellExitFailure !Int

# Documentation

newtype ShellT (m :: Type -> Type) a Source #

Shell transformer.

Constructors

ShellT |

Fields

- runShellT :: ResourceT m a

#### Instances

Instances details

MonadTrans ShellT Source # |
Instance details Defined in Data.Conduit.Shell.Types Methods lift :: Monad m => m a -> ShellT m a Source #
MonadIO m => MonadIO (ShellT m) Source # |
Instance details Defined in Data.Conduit.Shell.Types Methods liftIO :: IO a -> ShellT m a Source #
MonadThrow m => MonadThrow (ShellT m) Source # |
Instance details Defined in Data.Conduit.Shell.Types Methods throwM :: (HasCallStack, Exception e) => e -> ShellT m a Source #
Applicative m => Applicative (ShellT m) Source # |
Instance details Defined in Data.Conduit.Shell.Types Methods pure :: a -> ShellT m a Source # (<*>) :: ShellT m (a -> b) -> ShellT m a -> ShellT m b Source # liftA2 :: (a -> b -> c) -> ShellT m a -> ShellT m b -> ShellT m c Source # (*>) :: ShellT m a -> ShellT m b -> ShellT m b Source # (<*) :: ShellT m a -> ShellT m b -> ShellT m a Source #
Functor m => Functor (ShellT m) Source # |
Instance details Defined in Data.Conduit.Shell.Types Methods fmap :: (a -> b) -> ShellT m a -> ShellT m b Source # (<$) :: a -> ShellT m b -> ShellT m a Source #
Monad m => Monad (ShellT m) Source # |
Instance details Defined in Data.Conduit.Shell.Types Methods (>>=) :: ShellT m a -> (a -> ShellT m b) -> ShellT m b Source # (>>) :: ShellT m a -> ShellT m b -> ShellT m b Source # return :: a -> ShellT m a Source #
MonadUnliftIO m => MonadResource (ShellT m) Source # |
Instance details Defined in Data.Conduit.Shell.Types Methods liftResourceT :: ResourceT IO a -> ShellT m a Source #
(MonadUnliftIO (ShellT m), Applicative m, MonadThrow m) => Alternative (ConduitT i o (ShellT m)) Source # | Intentionally only handles `ShellException`. Use normal exception handling to handle usual exceptions.
Instance details Defined in Data.Conduit.Shell.Types Methods empty :: ConduitT i o (ShellT m) a Source # (<|>) :: ConduitT i o (ShellT m) a -> ConduitT i o (ShellT m) a -> ConduitT i o (ShellT m) a Source # some :: ConduitT i o (ShellT m) a -> ConduitT i o (ShellT m) [a] Source # many :: ConduitT i o (ShellT m) a -> ConduitT i o (ShellT m) [a] Source #

data ShellException Source #

An exception resulting from a shell command.

Constructors

ShellEmpty | For `mempty`.
ShellExitFailure !Int | Process exited with failure.

#### Instances

Instances details

Exception ShellException Source # |
Instance details Defined in Data.Conduit.Shell.Types Methods toException :: ShellException -> SomeException Source # fromException :: SomeException -> Maybe ShellException Source # displayException :: ShellException -> String Source # backtraceDesired :: ShellException -> Bool Source #
Show ShellException Source # |
Instance details Defined in Data.Conduit.Shell.Types Methods showsPrec :: Int -> ShellException -> ShowS Source # show :: ShellException -> String Source # showList :: [ShellException] -> ShowS Source #